package seniordesign.harambe;

import android.app.Activity;
import android.bluetooth.BluetoothGattCharacteristic;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.content.SharedPreferences;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.IBinder;
import android.preference.PreferenceManager;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.widget.TextView;

import seniordesign.harambe.ui.preferenceValues;
//
public class BLEActivity extends Activity {


    private BluetoothLeService mBluetoothLeService;


    private boolean mConnected = false;
    private String TAG2 = "BLEActivity tag: ";
    private String mDeviceAddress;
    private TextView LED0Text;
    public TextView LED1Text;
    private TextView dataService;
    private String mDeviceName;
    private BluetoothGattCharacteristic mNotifyCharacteristic;
    private TextView updateLED0Data;
    private TextView updateLED1Data;
    private boolean isInterrupted  = false;

    SharedPreferences prefs;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_ble);
        prefs = getPreference();
        LED0Text = (TextView) findViewById(R.id.LED0DATA);
        LED1Text = (TextView) findViewById(R.id.LED1DATA);
        dataService = (TextView) findViewById(R.id.DATASERVICE);

        mDeviceAddress = getPreferencesString(preferenceValues.SAVEADDRESS.name());
        mDeviceName = getPreferencesString(preferenceValues.SAVENAME.name());

        Intent i = new Intent(BLEActivity.this, BluetoothLeService.class);
        bindService(i, mServiceConnection, BIND_AUTO_CREATE);

        new updateData().execute();
        //
        //   notifyLED();


        // Ensures Bluetooth is available on the device and it is enabled. If not,
// displays a dialog requesting user permission to enable Bluetooth.


    }

    private String getPreferencesString(String get) {
        //SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(MainActivity.this);
        //   prefs = getPreference();
        if (get.equals(preferenceValues.SAVENAME.name())) {
            return prefs.getString(get, "");
        }
        if (get.equals(preferenceValues.SAVEADDRESS.name())) {
            return prefs.getString(get, "");
        }
        if (get.equals(preferenceValues.SAVEBLUETOOTH.name())) {
            return prefs.getString(get, "");
        }
        return null;
    }

    private SharedPreferences getPreference() {
        prefs = PreferenceManager.getDefaultSharedPreferences(this);
        return prefs;
    }

    @Override
    protected void onPause() {
        super.onPause();
        //  unregisterReceiver(mGattUpdateReceiver);

    }

    private final ServiceConnection mServiceConnection = new ServiceConnection() {

        @Override
        public void onServiceConnected(ComponentName componentName, IBinder service) {
            mBluetoothLeService = ((BluetoothLeService.LocalBinder) service).getService();
            Log.d(TAG2, mBluetoothLeService + " sir");
            if (!mBluetoothLeService.initialize()) {
                Log.e(TAG2, "Unable to initialize Bluetooth");
                finish();
            }
            Log.d(TAG2, mBluetoothLeService + " sir");
            // Automatically connects to the device upon successful start-up initialization.
            // Automatically connects to the device upon successful start-up initialization.
            mBluetoothLeService.connect(mDeviceAddress);


        }

        @Override
        public void onServiceDisconnected(ComponentName componentName) {
            mBluetoothLeService = null;
        }
    };

    @Override
    protected void onStop() {

        //     unregisterReceiver(mGattUpdateReceiver);

        super.onStop();
    }

    protected void onDestroy() {
        super.onDestroy();
        // unregisterReceiver(mGattUpdateReceiver);
        Log.i(TAG2, "On destroy");
        if (mBluetoothLeService != null)
            unbindService(mServiceConnection);
        //  mBluetoothLeService.disconnect();


        //   unregisterReceiver(mGattUpdateReceiver);

        //  safePreferences();
        //   Log.i(TAG2, "On destroy");
        //  if (mBluetoothLeService!=null)
        //     unbindService(mServiceConnection);
        //  mBluetoothLeService.disconnect();
        isInterrupted = true;
    }

    private final BroadcastReceiver mGattUpdateReceiver = new BroadcastReceiver() {
        @Override
        public void onReceive(Context context, Intent intent) {
            final String action = intent.getAction();
            if (BluetoothLeService.ACTION_GATT_CONNECTED.equals(action)) {

                //      updateConnectionState(R.string.connected);
                //      invalidateOptionsMenu();
            } else if (BluetoothLeService.ACTION_GATT_DISCONNECTED.equals(action)) {
                mConnected = false;
                //    updateConnectionState(R.string.disconnected);
                //     invalidateOptionsMenu();
                //     clearUI();
            } else if (BluetoothLeService.ACTION_GATT_SERVICES_DISCOVERED.equals(action)) {
                // Show all the supported services and characteristics on the user interface.
                //       displayGattServices(mBluetoothLeService.getSupportedGattServices());
            } else if (BluetoothLeService.ACTION_DATA_AVAILABLE.equals(action)) {
                //     displayData(intent.getStringExtra(BluetoothLeService.EXTRA_DATA));
            }
        }
    };

  //  private void updateLED0() {
    //    LED0Text.setText(mBluetoothLeService//.getLED0());
   // }


  //  private void updateLED1() {
  //      LED1Text.setText(mBluetoothLeService.getLED1());
  //  }

    private void gettoData() {
        dataService.setText(mBluetoothLeService.getDataService());
    }


    private void displayData(String data) {
        if (data != null) {
            //  mDataField.setText(data);
        }
    }

    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.ble_activity_menu, menu);

        return true;
    }

    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.updateLED0:
            //    updateLED0();
                return true;
            case R.id.updateLED1:
            //    updateLED1();
                return true;
            case R.id.updateDATAservice:
                gettoData();
                return true;
        }

        return false;
    }

    private class updateData extends AsyncTask<Void, Void, Void> {
        @Override
        protected void onPreExecute() {

        }

        @Override
        protected Void doInBackground(Void... voids) {
            Thread t = new Thread() {

                @Override
                public void run() {
                    try {
                        while (!isInterrupted) {
                            Thread.sleep(1000);
                            runOnUiThread(new Runnable() {
                                @Override
                                public void run() {
                                    try {
                                  //      LED0Text.setText(mBluetoothLeService.getLED0());
                                  //      Thread.sleep(100);
                                  //      LED1Text.setText(mBluetoothLeService.getLED1());
                                  //      Thread.sleep(100);
                                        dataService.setText(mBluetoothLeService.getDataService());
                                        Log.i(TAG2, "check");
                                        Thread.sleep(100);
                                    } catch (InterruptedException e){
                                            Log.i(TAG2, "Could not update UI within" + e);
                                    }

                                }
                            });
                        }
                    } catch (InterruptedException e) {
                    }
                }
            };

            t.start();
            return null;
        }
    }
}
