package seniordesign.harambe;


import android.content.ComponentName;
import android.content.Intent;
import android.content.ServiceConnection;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.os.IBinder;
import android.preference.PreferenceManager;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.app.FragmentStatePagerAdapter;
import android.support.v4.view.ViewPager;
import android.support.v7.app.ActionBar;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;

import seniordesign.harambe.ui.preferenceValues;

public class DataActivity extends AppCompatActivity {
    private BluetoothLeService mBluetoothLeService;
    public static final String ARG_SECTION_NUMBER = "1";
    String TAG = "dataActivity";
    private boolean mConnected = false;
    private String mDeviceAddress;
    private String mDeviceName = "1";
    ViewPager page;
    SharedPreferences prefs;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_data);
        ViewPager page;
        SectionsPagerAdapter adapter;
        adapter = new SectionsPagerAdapter(getSupportFragmentManager());

        Intent i = new Intent(this, BluetoothLeService.class);
        bindService(i, mServiceConnection, BIND_AUTO_CREATE);
        //  Log.i("Fragment", mBluetoothLeService + " " + "In DataActivity");

        page = (ViewPager) findViewById(R.id.viewPager);
        Log.i(TAG, " " + page + "   " + adapter);

        page.setAdapter(adapter);


    }


    public class SectionsPagerAdapter extends FragmentStatePagerAdapter {

        public SectionsPagerAdapter(FragmentManager fm) {
            super(fm);
        }

        @Override
        public Fragment getItem(int position) {

            switch (position) {
                case 0:
                    return DataFragment.newInstance();
                case 1:
                    return DataServiceHistoryFragment.newInstance();
                case 2:
                    return DataFragmentSomeData.newInstance();
                case 3:
                    return DataServiceStreamHistory.newInstance();
                case 4:
                    return DataServiceLastFragment.newInstance();
                case 5:
                    return AlmostLastJacobFragment.newInstance();
                case 6:
                    return LastFragmentAccordingtoJacob.newInstance();


            }
            return null;
        }

        @Override
        public int getCount() {
            return 7;
        }
    }

    public String getDataService() {
        if (mBluetoothLeService == null)
            return "No Data";
        return mBluetoothLeService.getDataService(); // 1

    }

    public String getAccelX() {
        if (mBluetoothLeService == null)
            return "No Data";
        return mBluetoothLeService.getDataStreamX(); // 5
    }

    public String getAccelY() {
        if (mBluetoothLeService == null)
            return "No Data";
        return mBluetoothLeService.getDataStreamY(); // 6
    }

    public String getStreamService() {
        if (mBluetoothLeService == null)
            return "No Data";
        return mBluetoothLeService.getDataStream(); // 3

    }

    public String getSomeStreamService() {
        if (mBluetoothLeService == null)
            return "No Data";
        return mBluetoothLeService.getSomeDataService(); // 2

    }

    public String getMoreStreamService() {
        if (mBluetoothLeService == null)
            return "No Data";
        return mBluetoothLeService.getMoreDataStream(); // 4

    }

    public BluetoothLeService getYourObjects() {
        //     Log.i("Fragment", mBluetoothLeService + " " + "In DataActivity4" + " " + mDeviceAddress + " " + mDeviceName) ;
        if (mBluetoothLeService != null)
            return mBluetoothLeService;

        return null;
    }

    @Override
    public void onResume() {
        super.onResume();

        page = (ViewPager) findViewById(R.id.viewPager);
    }

    private String getPreferencesString(String get) {
        //SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(MainActivity.this);
        //   prefs = getPreference();
        if (get.equals(preferenceValues.SAVENAME.name())) {
            return prefs.getString(get, "");
        }
        if (get.equals(preferenceValues.SAVEADDRESS.name())) {
            return prefs.getString(get, "");
        }
        if (get.equals(preferenceValues.SAVEBLUETOOTH.name())) {
            return prefs.getString(get, "");
        }
        return null;
    }

    protected void onPause() {
        super.onPause();
        //     unbindService(mServiceConnection);

    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        unbindService(mServiceConnection);

    }

    @Override
    protected void onStop() {

        super.onStop();
    }


    private final ServiceConnection mServiceConnection = new ServiceConnection() {

        @Override
        public void onServiceConnected(ComponentName componentName, IBinder service) {
            prefs = PreferenceManager.getDefaultSharedPreferences(DataActivity.this);

            mDeviceAddress = getPreferencesString(preferenceValues.SAVEADDRESS.name());
            mDeviceName = getPreferencesString(preferenceValues.SAVENAME.name());

            mBluetoothLeService = ((BluetoothLeService.LocalBinder) service).getService();

            //  Log.d(TAG2, mBluetoothLeService +  " sir");
            if (!mBluetoothLeService.initialize()) {
                //   Log.e(TAG2, "Unable to initialize Bluetooth");
                finish();
            }
            //   Log.i("Fragment", mBluetoothLeService + " " + "In DataActivity2" + " " + mDeviceAddress + " " + mDeviceName) ;
            mBluetoothLeService.connect(mDeviceAddress);
            //   Log.i("Fragment", mBluetoothLeService + " " + "In DataActivity3" + " " + mDeviceAddress + " " + mDeviceName) ;


        }

        @Override
        public void onServiceDisconnected(ComponentName componentName) {
            mBluetoothLeService = null;
        }
    };


    public ActionBar setActionBarTitle(ActionBar bar, int i) {
        switch (i) {
            case 0:
                bar.setTitle("hi");
                return bar;
            case 1:
                bar.setTitle("hello");
                return bar;
            case 2:
                //      return DataFragmentSomeData.newInstance();
            case 3:
                //      return DataServiceStreamHistory.newInstance();
            case 4:
                //     return DataServiceLastFragment.newInstance();
            default:
                return bar;
        }
    }

    /*
    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.view_graph, menu);
        return true;
    }
    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        switch (item.getItemId()) {
            case R.id.viewGraph:
                // Do Activity menu item stuff here
                return true;
            default:
                break;
        }
        return false;
    }
    */
    public void onSectionAttached(int number) {
        switch (number) {
            case 1:
                // Your code
                break;
            case 2:
                // your code
                break;
        }
    }
}
    /*
    @Override
    public void onBackPressed() {
            Fragment fragment = (Fragment) getSupportFragmentManager().findFragmentByTag("android:switcher:" + R.id.viewPager + ":" + page.getCurrentItem());
            if (fragment != null) // could be null if not instantiated yet
            {
                if (fragment.getView() != null) {
                    // Pop the backstack on the ChildManager if there is any. If not, close this activity as normal.
                    if (!fragment.getChildFragmentManager().popBackStackImmediate()) {
                        finish();
                    }
                }

        }
    }
}
*/